#!/usr/bin/perl
use strict;

my ($fdr, $hmm_file, $db_size) = @ARGV;

die "provide a desired FDR\n" unless $fdr;
die "provide the path to an HMM file\n" unless $hmm_file;
$db_size = 3102 unless $db_size;

my $line;
my %tp_cnts;
open FH, "<exp_tp.cnts";
while ($line=<FH>) {
   my @vals = split (/\s+/, $line);
   $tp_cnts{$vals[0]} = $vals[1];
}

open FH, "<$hmm_file";
my $line;
while ($line=<FH>) {
   last if $line !~ /^#/;  #skip comments, which include a url that'll break the "//" split
}
seek (FH, -1*length($line), 1 ); # back up to grab the first line again.

$/ = "//";

my $hmm;
while ( $hmm = <FH>) { 
   $hmm =~ s/^\s+//s;
   next unless $hmm;
   
   my ($acc) = ($hmm =~ /(DF000\d+)/);
   my $e_target = $tp_cnts{$acc} * $fdr;

   open OUT, ">tmp.hmm";
   print OUT $hmm;
   close OUT;

   my $cmd = "hmmstat --eval2score --rescntZ -Z $db_size -E $e_target tmp.hmm";
   my $res = `$cmd | tail -1`;
   my ($nc) = ($res =~ /.+(\d+\.\d+)\s*$/);
   #print "$acc $nc\n";

   $hmm =~ s/(NC\s+)(\S+);/$1$nc;/;
   print "$hmm\n";

}

