#!/usr/bin/perl
$|++;

my ($dir, $ga) = @ARGV;

my %gas;
open FH, "<$ga";
while ($line = <FH>) {
   ($id, $ga) = split(/\s+/, $line);
   $gas{$id} = $ga;
}


my %target_conversion;
my $target_cnt = 0;

foreach $file (glob ("$dir/*") )  {

   open FH, "<$file";   
   
   $file =~ /(DF.+?)\./;
   $ga = $gas{$1};
   
   print "$file ($ga)";
   
   my $bases=0; 
   while ($line = <FH>) {

      next if $line =~ /^#/;

      my @vals = split (/\s+/, $line);
      next if ($vals[6] < $ga);
      my ($target, $alistart, $aliend) = @vals[0,1,2];
      
      my $id = $target_conversion{$target};
      unless ($id) {
         #haven't seen this one before
         $target_cnt++;
         $id = $target_cnt; 
         $target_conversion{$target} = $id;
      }

      $bases += $aliend-$alistart+1;
      for $i ($alistart..$aliend) {
         $coverages[$id][$i] = 1; 
      }
   }
   print "   [$bases]\n";
   

}

$covered_cnt = 0;
foreach $target_coverages (@coverages) {
   foreach $c (@$target_coverages) {
      $covered_cnt += $c;
   }
}

print "Total covered : $covered_cnt\n";  
