#!/usr/bin/perl


($outfilename, $block_size, @infilenames) = @ARGV;


$block_size ||= 60000;

open OUT, ">$outfilename";


foreach $infilename (@infilenames) {
   open FH, "<$infilename";
   $line = <FH>;
   close FH;
   ($seqname) = ($line =~ />(\S+)/);

print STDERR "$infilename\n";

   $rescnt =  0 +`esl-seqstat --dna -c $infilename | awk '/# residues/ {print \$4}'`;

   $s = 1; 
   $e = $s + $block_size - 1;
   while ($e<$rescnt ) { 
   
      `esl-sfetch -c $s..$e $infilename \"$seqname\" > /tmp/seqs.tmp`;
      $comp = `esl-seqstat --dna -c -a /tmp/seqs.tmp`;

      ($header,@counts) = ($comp =~ /= (\S+).+: A\s+(\d+).+: C\s+(\d+).+: G\s+(\d+).+: T\s+(\d+)(?:.+: N\s+(\d+))?/s);
   
      #only keep blocks that are only fractionally Ns
      if ($counts[4] < $block_size * .1) {
         print OUT `cat /tmp/seqs.tmp`;
         $gc_pct = ($counts[1]+$counts[2])/($counts[0]+$counts[1]+$counts[2]+$counts[3]);
         printf ("$header : %.3f\n", $gc_pct);      
      }

      unlink "/tmp/seqs.tmp";   

      $s = $e+1;
      $e = $s + $block_size - 1;
   }
}
close OUT;