#!/usr/bin/perl
$| = 1;
my ($dir, $gafile) = @ARGV; # e.g. rmblastn_std, ../0803-Dfam-benchmark-with-final-models/GAs/rmblastn.f002.ga


my %gas;
open FH, "<$gafile";
while ($line = <FH>) {
   ($q,$g) = split /\s/, $line;
   $gas{$q} = $g;
}
close FH;

#heavy handed. use a text bit mask to determine coverage/overextension
open FH, "<bait_locations.txt";

my %baits;
while ($line = <FH>) {
   my ($name) = ($line =~ /(\S+):/);
   #print STDERR "$name\n";
   while ($line =~ /(\d+)\.\.(\d+)/g) {
      for $i ($1..$2) {
            $baits{$name}[$i] = 1;
      }
   }
   #print STDERR "\n";
}
close FH;


my %matches; 
foreach $file (glob ( "$dir/*") ) {

   open FH, "<$file";
   $file =~ s[.+/(.+)\..+][$1];
   $ga = $gas{$file};
   print STDERR "$file: [$ga]\n";
   
   $curr_target = "";
   $i = 0;
   while ($line = <FH>) {
      next if $line =~ /^#/;
      
      ($target, $t_start, $t_end, $q_start, $q_end, $orient, $score) = split /\s+/, $line;
      next if ($score < $ga);      
      next unless $baits{$target};
      for $i ($t_start..$t_end) {
            $matches{$target}[$i] = 1;
      }
   }
   close FH;   
}      
      
      
my $good_tot = 0;
my $bad_tot = 0;
foreach $key ( sort keys %baits ) {
   my $good = 0;
   my $bad = 0;
   for $i (0..$#{$baits{$key}}) {
      if ($baits{$key}[$i] && $matches{$key}[$i] ) {
         $good++;
      } elsif ( $matches{$key}[$i] ) {
         $bad++;
      }
   }
   print "$key: good:$good,  bad:$bad\n";
   $good_tot += $good;
   $bad_tot  += $bad;   
}

print "total: good:$good_tot,  bad:$bad_tot\n";
