#!/usr/bin/perl
$|++;

$dir = "../1022-Dfam-table1-revision/search_results/";


#read in GAs:
%GAs;
open FH, "<./crossmatch.ga";
while ($line = <FH>) {
   my ($name, $ga) = split(/\s+/, $line);
   $GAs{"cross_match,$name"} = $ga;
}
open FH, "<./nhmmer.ga";
while ($line = <FH>) {
   my ($name, $ga) = split(/\s+/, $line);
   $GAs{"nhmmer,$name"} = $ga;
}
open FH, "<./rmblastn.ga";
while ($line = <FH>) {
   my ($name, $ga) = split(/\s+/, $line);
   $GAs{"rmblastn,$name"} = $ga;
}


foreach $file (glob ("$dir/cross_match/*out"), glob ("$dir/nhmmer/*out"), glob ("$dir/rmblastn/*out"),  )  {
 
   my $char;
   ($char = "C" and $tool = "cross_match") if $file =~ /cross|CM/;
   ($char = "N" and $tool = "nhmmer") if $file =~ /hmmer/;
   ($char = "B" and $tool = "rmblastn") if $file =~ /blast/;      
  
   ($name) = ($file =~ m[.+/\S+/([^.]+)] );

   $ga = $GAs{"$tool,$name"} + 0; 

   open FH, "<$file";  
   print STDERR "$file ($ga)";
   my $cnt=0; 
   while ($line = <FH>) {

      my @vals = split (/\s+/, $line);
      ($target, $alistart, $aliend, $score) = @vals[0,1,2,6];
   
      if ($score >= $ga) {
         $cnt += $aliend-$alistart+1;
         for $i ($alistart..$aliend) {
            $coverages{$target}[$i] .= $char unless $coverages{$target}[$i] =~/$char/;
         }
      }
   }
   print STDERR "   [$cnt]\n";
}


my $covered = 0;
foreach $key ( sort keys %coverages ) {

   my @starts;
   my @ends;

   for $i (1..60000) { #I know that's the length of each block of sequence
     $coverages{$key}[$i] =  ($coverages{$key}[$i] eq "CNB") ? 1 : 0 ;
   }
   
   $str = join ("",  @{$coverages{$key}});
   
   while ( $str =~ /(1+)/g ) {
      push @starts, pos($str)-length($1)+1;
      push @ends, pos($str);
   }
   
   printf ("%30s : ", $key);  
   
   my $cnt = 0;
   for $i(0..$#starts) {
      print "$starts[$i]..$ends[$i], ";
      $cnt += $ends[$i]-$starts[$i]+1;
   }
   print " [ $cnt ]\n";
   $covered += $cnt; 
   
   
   $coverages{$key} = 0;  # clear memory
}    

print "Total covered : $covered\n";  
