#!/usr/bin/perl
$|++;

open FH, "<covered.intersect";

my %bait_lines;
while ($line = <FH>) {
   $line =~ /(\S+) : (.+) \[.+\]/;
   $bait_lines{$1} = $2; 
}


open FH, "<../1007-Dfam-test-benchmark-unihit/60Kb.blocks.fa";
$/ = ">";
<FH>;
while ($entry = <FH>) {
   ($header, $seq) = ($entry =~ /(\S+).*?\n(.+?)(?:>|$)/s);
   $seq =~ s/\s//g;
   $bait_line = $bait_lines{$header};


   #capture bait and traps (inter-bait sequence)
   $trap = "";
   @baits = ();
   $prev_end = 0;
   while ( $bait_line =~ /(\d+)\.\.(\d+)/g ) {
      $start = $1;
      $end = $2;
      
      $trap .= substr($seq, $prev_end, $start-$prev_end-1); # prev_end is 1 less than the prebait start ... $start is 1 after prebait end, so offsets are different
      $bait    = substr($seq, $start-1, $end-$start+1);
      
      push @baits, $bait;
      $prev_end = $end;
   }  
   $trap .= substr($seq, $prev_end, 60000-$prev_end); # prev_end is 1 less than the prebait start ... $start is 1 after prebait end, so offsets are different 

   #trim bait, reverse order
   @tmp_baits = ();
   foreach $bait (@baits) {
      $blen += length($bait);
      unshift @tmp_baits, $bait;  #don't trim
      #if ( length ($bait) >= 50 ) {  # don't bother with shorter, they'll be length 30 after trimming, too short to be useful for this test.
      #   unshift @tmp_baits, substr($bait, 10, length($bait)-20);
      #}
   }
   @baits = @tmp_baits;

   #reverse and split trap sequence
   $trap = reverse($trap);
   $cnt = $#baits+1;
   $trap_part_len = int(length($trap)/($cnt+1));
   #this will cause the final block to pick up all the remaining characters after the nearly-even divide. That's ok with me.
   my @traps = unpack("(A$trap_part_len)*", $trap);
   if ( length($traps[-1]) !=  $trap_part_len ) {
      $traps[-2] .= $traps[-1] ;
      pop @traps;
   }
   
   
   #create new sequence:
   print STDERR "$header:";   
   $seq = "";
   $st = 0;
   for $i (0..$#baits) {
      $st += length($traps[$i]);
      $end = $st + length($baits[$i]) - 1;
      print STDERR "$st..$end ";
      
      $st = $end+1;
      $seq .= $traps[$i] . $baits[$i];
   }   
   $seq .= $traps[-1];
   
   print STDERR "\n";   
   print ">$header\n$seq\n";
   
}

